#include "include/slam_manager.h"
#include "include/data/package_line.h"


#include "ara/log/logging.h"
#include "SLAM_GeneralWrapper.h"
#include "slam/executable.h"

#include "ara/com/internal/skeleton/skeleton_adapter.h"
#include "ara/com/internal/skeleton/event_adapter.h"
#include "ara/com/internal/skeleton/field_adapter.h"
#include "ara/com/internal/skeleton/method_adapter.h"

int main()
{

	// Logger for wrapper
	// ara headers must be added
	ara::log::InitLogging("DPC", "SLAM_TEST", ara::log::LogLevel::kFatal, (ara::log::LogMode::kConsole | ara::log::LogMode::kRemote));

	ara::log::Logger &mainLog { ara::log::CreateLogger("main", "slam sample context", ara::log::LogLevel::kVerbose) };

	mainLog.LogInfo() << "Let's produce some slam data...";

//	GeneralWrapper gw(mainLog);

	// dpc::position slam_position_data;

	// float counter = 0;
	using namespace jac::ap::slamservice::skeleton;
	using namespace ara::com;
	using namespace ara::core;
	std::shared_ptr<SLAMServiceSkeleton> skeleton_;
	skeleton_ = std::make_shared<SLAMServiceSkeleton>(InstanceSpecifier(
			        "slam/slam/SLAM2EMpositionPPort"),
			        MethodCallProcessingMode::kEvent);

	skeleton_->OfferService();
	auto data         = skeleton_->PositionEvent.Allocate();
	while(1)
	{
		skeleton_->PositionEvent.Send(std::move(data));
		// counter += 1;
		// slam_position_data.x = counter;
        // gw._SLAM2EMposition_Provide.s.SetData(slam_position_data);
//       	gw._SLAM2EMposition_Provide.Publish();
//        gw._SLAM2EMattribute_Provide.Publish();
//        gw._SLAM2EMline_point_Provide.Publish();
//        gw._SLAM2EMline_Provide.Publish();
//        gw._SLAM2EMspeed_limit_Provide.Publish();
//        gw._SLAM2EMtraffic_object_Provide.Publish();
//        gw._SLAM2EMlane_Provide.Publish();
//        gw._SLAM2EMroad_edge_Provide.Publish();
//        gw._SLAM2EMslam_road_model_Provide.Publish();
//        gw._SLAM2DMAdjacentExtendLaneStruct_Provide.Publish();
//        gw._SLAM2DMSMAStruct_Provide.Publish();
//        gw._SLAM2DMWPExtendLaneStruct_Provide.Publish();
//        gw._SLAM2DMRemindWaypointStruct_Provide.Publish();
//        gw._SLAM2DMControlWaypointStruct_Provide.Publish();
//        gw._SLAM2DMMsgHeader_Provide.Publish();
//        gw._SLAM2DMTransitLaneStruct_Provide.Publish();
//        gw._SLAM2DMControlWaypoints_Provide.Publish();

		std::this_thread::sleep_for(std::chrono::milliseconds(300));
		// printf("test\n");
	}
}
